<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>
    <script src="utils.js"></script>

    <link rel="import" href="../dez-canvas.html">
  </head>
  <body>

    <test-fixture id="ChangedPropertyTestFixture">
      <template>
        <dez-canvas bg="../demo/magritte.jpg"></dez-canvas>
      </template>
    </test-fixture>

    <test-fixture id="TriangleTestFixture">
      <template>
        <dez-canvas
            grobs-data='[
                {"type": "Triangle", "text": "one triangle", "x": 200, "lg": 30, "color": "red", "lines": [0]}
            ]'
            grid-data= '{
                "lines": [
                    {"bottom" : 200.0, "top": 55.0}
                ]
            }'
        ></dez-canvas>
      </template>
    </test-fixture>

    <script>

    const LINE_HEIGHT = 30
    const INTERLINE = 2
    const NB_TOP_LINES = 3

    suite ('Triangle Tests', function () {
      setup (function () {
        this._element = fixture('TriangleTestFixture');
        this._svgElement = new GesturesListenerElement(this._element.shadowRoot.querySelector('svg'));
        this.leftMargin = getLeftMargin(this._element);
        this.timeout = 100;
        this._topHeight = (LINE_HEIGHT + INTERLINE) * NB_TOP_LINES
      });

      test ('Triangle creation', function (done) {
        setTimeout(function () {
          let textElement = this._element.shadowRoot.querySelector("svg>g>text")
          assert.equal(textElement.innerHTML, "one triangle");

          let polygonElement = this._element.shadowRoot.querySelector("svg>g>polygon")
          assert.equal(
            polygonElement.getAttribute("points"),
            "185," + parseInt(80+this._topHeight) + ",215," + parseInt(80+this._topHeight) + ",200," + parseFloat(152.5+this._topHeight))
            done()
        }.bind(this), this.timeout);
      });

      // test('moving a triangle...', function(done) {
      //     setTimeout(function () {
      //         this._svgElement.trackStartAt(200+this.leftMargin, 90).moveTo(300+this.leftMargin, 90).stop();
      //         let polygonElement = this._element.shadowRoot.querySelector("svg>g>polygon");
      //         assert.equal(polygonElement.getAttribute("points"), "285,80,315,80,300,152.5");
      //         done()
      //     }.bind(this), this.timeout);
      // });
    });

    </script>

  </body>
</html>
